import tensorflow as tf
tf.GraphKeys.VARIABLES = tf.GraphKeys.GLOBAL_VARIABLES
from tensorflow.examples.tutorials.mnist import input_data as mnist_data

X = tf.placeholder(tf.float32, [None, 28, 28, 1]) # batch de imagens X
# cria e inicializa aleatoriamente os pesos com distribuicao normal e sigma=0.1
W1 = tf.Variable(tf.truncated_normal([784, 128], stddev=0.1))
# bias sao inicializados com valores fixos 1/10
B1 = tf.Variable(tf.ones([128])/10)
W2 = tf.Variable(tf.truncated_normal([128, 64], stddev=0.1))
B2 = tf.Variable(tf.ones([64])/10)
W3 = tf.Variable(tf.truncated_normal([64, 10], stddev=0.1))
B3 = tf.Variable(tf.zeros([10]))
Y = tf.placeholder(tf.float32, [None, 10]) # classes das imagens em X

# entrada redimensionada
X1 = tf.reshape(X, [-1, 784])

# modelos das representacoes intermediarias
X2 = tf.nn.relu(tf.matmul(X1, W1) + B1)
X3 = tf.nn.relu(tf.matmul(X2, W2) + B2)

# saida da rede (a.k.a. logits)
X4 = tf.matmul(X3, W3) + B3
# classificacao softmax
Y_ = tf.nn.softmax(X4)

# utilizamos uma funcao pronta no TF para calculo da entropia cruzada
entropia_cruzada = tf.nn.softmax_cross_entropy_with_logits(logits=X4, labels=Y_)
entropia_cruzada = tf.reduce_mean(entropia_cruzada)*100


eh_correto = tf.equal(tf.argmax(Y_,1), tf.argmax(Y,1))
acuracia = tf.reduce_mean(tf.cast(eh_correto, tf.float32))

# otimizacao com taxa de aprendizado 0.0025
otimiza = tf.train.AdamOptimizer(0.0025)
treinamento = otimiza.minimize(entropia_cruzada)

inicia = tf.global_variables_initializer() # instancia inicializacao
sess = tf.Session() # instancia sessao
sess.run(inicia)    # executa sessao e inicializa
# baixa base de dados mnist
mnist = mnist_data.read_data_sets("data", one_hot=True, reshape=False, validation_size=0)

# executa 500 iteracoes
for i in range(1000):
    # carrega batch de 100 imagens (X) e suas classes (Y)
    batch_X, batch_Y = mnist.train.next_batch(100)
    dados_trein={X: batch_X, Y: batch_Y}

    # treina com o batch atual
    sess.run(treinamento, feed_dict=dados_trein)
    # computa entropia-cruzada para acompanhar convergencia
    ce = sess.run(entropia_cruzada, feed_dict=dados_trein)
    print(str(ce))


dados_teste={X: mnist.test.images, Y: mnist.test.labels}
a,c = sess.run([acuracia, entropia_cruzada], feed_dict=dados_teste)
print("Teste:")
print("- Acuracia: ",str(a))
print("- Loss: ",str(c))
