import tensorflow as tf
tf.GraphKeys.VARIABLES = tf.GraphKeys.GLOBAL_VARIABLES
from tensorflow.examples.tutorials.mnist import input_data as mnist_data
# variaveis (matrizes e vetores) 
X = tf.placeholder(tf.float32, [None, 28, 28, 1]) # batch de imagens X
W = tf.Variable(tf.zeros([784, 10])) # pesos
b = tf.Variable(tf.zeros([10])) # bias
Y = tf.placeholder(tf.float32, [None, 10]) # classes das imagens em X
inicia = tf.global_variables_initializer() # instancia inicializacao

# modelo que ira gerar as predicoes com base nas imagens vetorizadas
Y_ = tf.nn.softmax(tf.matmul(tf.reshape(X, [-1, 784]), W) + b)

# define funcao de custo (entropia cruzada)
entropia_cruzada = -tf.reduce_sum(Y * tf.log(Y_+0.0001))

eh_correto = tf.equal(tf.argmax(Y_,1), tf.argmax(Y,1))
acuracia = tf.reduce_mean(tf.cast(eh_correto, tf.float32))

# otimizacao com taxa de aprendizado 0.0025
otimiza = tf.train.GradientDescentOptimizer(0.0025)
treinamento = otimiza.minimize(entropia_cruzada)

sess = tf.Session() # instancia sessao
sess.run(inicia)    # executa sessao e inicializa
# baixa base de dados mnist
mnist = mnist_data.read_data_sets("data", one_hot=True, reshape=False, validation_size=0)

# executa 200 iteracoes
for i in range(200):
    # carrega batch de 64 imagens (X) e suas classes (Y)
    batch_X, batch_Y = mnist.train.next_batch(64)
    dados_trein={X: batch_X, Y: batch_Y}

    # treina com o batch atual
    sess.run(treinamento, feed_dict=dados_trein)
    # computa entropia-cruzada para acompanhar convergencia
    ce = sess.run(entropia_cruzada, feed_dict=dados_trein)
    print(str(ce))


dados_teste={X: mnist.test.images, Y: mnist.test.labels}
a,c = sess.run([acuracia, entropia_cruzada], feed_dict=dados_teste)
print("Teste:")
print("- Acuracia: ",str(a))
print("- Loss: ",str(c))
